//#include <getopt.h>
#include <stdlib.h>
#include <unix_buffer.H>
#include <fstream>
#include <string>

using namespace std;

const int server_port = 12364;

void usage(void)
{
  cout << "usage: transfer-client [-h] [-v] [-g]|-p [-i interval] [-f file] server" << endl;
  cout << "   -h           dieser Text" << endl;
  cout << "   -g           get-Modus zum Holen der Siebparameter" << endl;
  cout << "   -p           put-Modus zum Senden der Relationen" << endl;
  cout << "   -v           geschwtzig" << endl;
  cout << "   -i interval  Groesse des Polynomintervalls (default=25000)" << endl;
  cout << "   -f file      Speicher Daten in Datei file (default=qsieve-fc.param)" << endl;
}

int main(int argc, char *argv[])
{
  int polynome = 25000;
  char *server = NULL;
  char *file = NULL;
  bool get = true;
  bool option = false;
  bool help = false;
  bool verbose = false;
  char c;
  string s;
  int i;
  // parameter testen ;-)
  while ((i=getopt(argc, argv, "gpf:hi:v"))!=EOF)
    {
      switch (i)
	{
	case 'g':
	  if (option && !get)
	    {
	      cerr << "Fehler: -f und -p schliessen einander aus." << endl;
	      exit(1);
	    }
	  option = get = true;
	  break;
	case 'p':
	  if (option && get)
	    {
	      cerr << "Fehler: -f und -p schliessen einander aus." << endl;
	      exit(1);
	    }
	  option = true;
	  get = false;
	  break;
	case 'f':
	  if (file != NULL)
	    {
	      cerr << "Fehler: -f kann nur einmal angegeben werden" << endl;
	      exit(1);
	    }
	  file = optarg;
	  break;
	case 'h':
	  help = true;
	  usage();
	  break;
	case 'i':
	  polynome = atoi (optarg);
	  break;
	case 'v':
	  verbose = true;
	  break;
	default:
	  usage();
	  exit(1);
	}
    }
  
  if (file == NULL)
    {
      if (get)
	file = "qsieve-fc.param";
      else
	file = "qsieve-fc.param.out";
    }
  if (optind+1 != argc) {
    if (help) exit(0);
    cerr << "Falsche Parameterzahl" << endl;
    exit(1);
  }
  server = argv[optind];
  
  if(get)
    {
      ofstream file_stream(file, ios::out|ios::trunc);
      {
	unix_io_client communication_stream(server, server_port);
	communication_stream << "Hunger!" << endl;
	while (!communication_stream.eof())
	  {
	    communication_stream.get(c);
	    file_stream.put(c);
	  }
      }
      {
	unix_io_client communication_stream(server, server_port);
	communication_stream << "DynamicFactors?_ab_fpos 0" << endl;
	while (!communication_stream.eof())
	  {
	    communication_stream.get(c);
	    file_stream.put(c);
	  }
      }
      {
	unix_io_client communication_stream(server, server_port);
	communication_stream << "Polynom? " << polynome << endl;
	while (!communication_stream.eof())
	  {
	    communication_stream.get(c);
	    file_stream.put(c);
	  }
      }
    }
  else
    {
      ifstream file_stream(file, ios::in);
      char line[1024];
      while (file_stream.peek()!=EOF)
	{
	  int count = 50+1; // maximal count-1 Relationen am Block bertragen
          unix_io_client communication_stream(server, server_port);
          while (file_stream.peek()!=EOF && --count)
	  {
            communication_stream << "Relation! ";
            while (file_stream.peek()!='\n')
             {
               file_stream.get(line,1024,'\n');
               communication_stream << line;
               if (verbose) cout << line;
             }
            file_stream.get(c);
            communication_stream << endl;
            if (verbose) cout << endl;
          }
          communication_stream << "Relationsblock_Ende " << flush;
	  communication_stream >> s;
	  if (s!="empfangen.")
	    cerr << "Empfang der Relation nicht besttigt!" << endl;
          if (s=="ignoriert!")
            {
              cerr << "Oops! - Relationen passen dem Server nicht!" << endl;
              cerr << "Bitte prfen Sie, ob bertragene Filedaten aus "
                   << "\"" << file << "\"" << endl
                   << "zur aktuellen Faktorisierung des Servers gehren!"
                   << endl;
              exit(1);
            }
	}
    }
}
